config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  get 'projects/show'
  root to: 'namespaces#index'

  resources :namespaces do
    resources :namespaces

    resources :projects

    post 'seed'
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/namespace.rb
# frozen_string_literal: true

class Namespace < ApplicationRecord
  belongs_to :namespace
  has_many :namespaces

  has_many :projects
end

app/models/project.rb
# frozen_string_literal: true

class Project < ApplicationRecord
  belongs_to :namespace
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base

end

app/controllers/namespaces_controller.rb
# frozen_string_literal: true

class NamespacesController < ApplicationController
  def index
    @namespaces = Namespace.all
  end

  def show
    @namespace = Namespace.find(params[:id])
  end

  def new

  end

  def create

  end

  # POST /:id/seed
  def seed
    # seed this Namespace with AwesomeCo

    %x[rake db:seed:awesome_co[#{params[:namespace_id]}]] # NOTE huge security risk this way.

    # Rake::Task['db:seed:awesome_co'].invoke(id)
    redirect_to Namespace.find(params[:namespace_id])
  end
end

app/controllers/projects_controller.rb
# frozen_string_literal: true

class ProjectsController < ApplicationController
  def show
    @project = Namespace.find(params[:namespace_id]).projects.find(params[:id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/namespaces_helper.rb
module NamespacesHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RailsRakeSeed</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= stylesheet_link_tag 'application', 'https://cdn.jsdelivr.net/npm/uikit@3.11.1/dist/css/uikit.min.css', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <div class="uk-container uk-margin-large-top">
      <%= yield %>
    </div>
  </body>
</html>

app/views/namespaces/index.html.haml
%h2 Namespaces # index
%h3 (start from one of these namespaces)

- if @namespaces.any?
  %ul
    - @namespaces.each do |namespace|
      - text_to_show = namespace.namespace.nil? ? namespace.name : "#{namespace.name} (subgroup)"
      %li= link_to text_to_show, namespace

- else
  No namespaces. Did you run `$ bundle exec rake db:seed`?

app/views/namespaces/show.html.haml
- if @namespace.namespace
  = link_to @namespace.namespace do
    &lt;
    Back to
    = @namespace.name
- else
  = link_to namespaces_path do
    &lt; Back to index

.uk-container
  %h2= @namespace.name

  - if @namespace.projects.any?
    %h3 Projects
    %ul
      - @namespace.projects.each do |project|
        %li= link_to project.name, namespace_project_path(@namespace, project)
  - else
    No projects

.uk-container
  - if @namespace.namespaces.any?
    %h3 Sub-namespaces
    %ul
      - @namespace.namespaces.each do |namespace|
        %li= link_to namespace.name, namespace
  - else
    No sub-namespaces

%a.uk-button.uk-button-primary{href: namespace_seed_path(@namespace), data: { method: :post }} Seed AwesomeCo

app/views/projects/show.html.haml
%h2 Projects#show

%h3= @project.name

.uk-container
  My parent namespace is
  = link_to @project.namespace.name, @project.namespace